#-h- ccode.dat        271 asc 20-oct-80 02:16:59
## ccode: generated code information
#
common /ccode/ col, prevgo, genln
   integer col          # column indicator for generated code
   integer prevgo       # output line number of most recent unconditional goto
   integer genln        # counts lines of generated code
#-h- ccstk.dat        167 asc 20-oct-80 02:17:00
## ccstk: control stack common
#
common /ccstk/ ctkbas, cp
   pointer ctkbas       # pointer to end of the stack
   pointer cp           # pointer to top of the stack
#-h- cfold.dat        470 asc 20-oct-80 02:17:01
## cfold -- translator's internal folding such that
#  upper case letters are evalivalent to lower case letters
#  left bracket, [,  is equivalent to left brace, {
#  right bracket, ], is equivalent to right brace, }
#  accent, `,        is equivalent to atsign, @
#  caret, ^,         is equivalent to tilde, ~
#  backslash, :,     is equivalent to bar, |
#  bang, !,          is equivalent to bar, |
#
common /cfold/fold(128)
   integer fold         # equivalence map
#-h- cgc.dat          204 asc 20-oct-80 02:17:02
## cgc: garbage collector common
#
common /cgc/ siztab(DTMAX), firstp(DTMAX)
   integer siztab       # indicates block size or offset to size
   integer firstp       # indicates location of first pointer
#-h- cintp.dat        578 asc 20-oct-80 02:17:03
## cintp: interpreter common
#
common /cintp/ cfp, marksp, markcp, pos, trace, lptop, level,
      rtime, random, lastr
   pointer cfp          # pointer to current procedure frame
   integer marksp       # marked s stack height
   integer markcp       # marked c stack height
   integer pos          # &pos
   integer trace        # &trace
   integer lptop        # stack offset to loop data
   integer level        # current procedure nesting
   integer rtime        # job runtime when Icon began
   integer random       # &random
   integer lastr        # last random number
#-h- cio.dat          223 asc 20-oct-80 02:17:04
## cio:  i/o common
#
common /cio/ infd, outfd, errfd
   integer infd         # default input file descriptor
   integer outfd        # default output file descriptor
   integer errfd        # default error file descriptor
#-h- clab.dat         162 asc 20-oct-80 02:17:05
## clab -- global label
#
common /clab/ lstflb, lstilb
   integer lstflb       # last fortran label generated
   integer lstilb       # last icon label generated
#-h- clex.dat         828 asc 20-oct-80 02:17:06
## clex:  global variables for lexical analyzer
#
common /clex/ linbuf(MAXLIN), linbp, bseen, nseen,
              linect, oldct, peeked, lsttok, level, lstsub,
              tokpos, lstpos, lstnum
   character linbuf     # current source line
   integer linbp        # pointer into linbuf
   integer bseen        # YES if blank seen in input
   integer nseen        # YES if new line seen
   integer linect       # current line number
   integer oldct        # last line number
   integer peeked       # YES if current token has been pushed back
   integer lsttok       # last token value
   integer level        # include level
   integer lstsub       # last subtoken type
   integer tokpos       # position of token within source line
   integer lstpos       # last token position
   integer lstnum       # last token number
#-h- cmain.dat        284 asc 20-oct-80 02:17:07
## cmain: interface to the generated fortran code
#
common /cmain/ signal, label, flabel, line
   integer signal       # Icon signal
   integer label        # argument for the computed go to switch
   integer flabel       # failure label
   integer line         # current line number
#-h- cmem.dat        1174 asc 20-oct-80 02:17:08
## cmem: Icon memory common
#
common /cmem/ strbas, strfrp, strlmt, sqlbas, nxtsql, nsqls, intbas,
              nxtint, hepbas, hepfrp, sp, stkbas, theend
   pointer strbas   # base of the string region
   cpointer strfrp  # next free character in the string region
   cpointer strlmt  # one past last character in string region
   pointer sqlbas   # base of the string qualifier region
   pointer nxtsql   # pointer to next free qualifier (free list pointer)
   integer nsqls    # number of qualifiers allocated
   pointer intbas   # base of the integer region
   pointer nxtint   # pointer to next free integer (free list pointer)
   pointer hepbas   # base of the heap
   pointer hepfrp   # next free location in the heap
   pointer sp       # stack pointer, points to top of stack
   pointer stkbas   # base of the stack.  Note that sp < stkbas
   pointer theend   # last word in mem
   integer snull    # pointer to null string (first qualifier)
   equivalence (snull, sqlbas)
 
## blank common: system memory area
#
common mem(MEMSIZE)
   integer mem          # memory
   real rmem(1)  # to access mem as reals; must be changed later!
   equivalence (mem(1), rmem(1))
#-h- cparm.dat        394 asc 20-oct-80 02:17:08
define(NAMSIZ,7)
 
## cparm:  miscellaneous program parameters
#
common /cparm/ parms(100)
   character prgnam(NAMSIZ)
   equivalence (prgnam(1),parms(1))     # must be first
   integer alcoff(1)
   equivalence (alcoff(1),parms(8))
   integer tnoff(1)
   equivalence (tnoff(1),parms(9))
   integer jbver(1)
   equivalence (jbver(1),parms(10))
   integer gcflag
   equivalence (gcflag,parms(11))
#-h- csizes.dat       525 asc 20-oct-80 02:17:09
## csizes:  at program initialization, ???siz gives initial size
#  of region ???; later, it is size of accessible portion of the
#  region at the most recent expansion and is used in computing the
#  breathing room.
#
common /csizes/ strsiz, sqlsiz, intsiz, hepsiz, stksiz, intlb,
   intub
   integer strsiz
   integer sqlsiz
   integer intsiz
   integer hepsiz
   integer stksiz
   integer intlb        # lower bound of permanently allocated integers
   integer intub        # upper bound of permanently allocated integers
#-h- cstat.dat       1186 asc 20-oct-80 02:17:10
## cstat: storage management statistics common
#
define(NREGIONS,4)      # number of storage regions
define(STR,1)           # index for string region statistics
define(SQL,2)           # index for qualifier region statistics
define(INT,3)           # index for integer region statistics
define(HEAP,4)          # index for heap region statistics
define(STK,5)           # index for stack region (no statistics)
define(EXPD,6)          # expansion flag
common /cstat/ sstat(NREGIONS), ncalls(NREGIONS), nallc(NREGIONS),
   ngcs(NREGIONS), nxpn(NREGIONS), nrec(NREGIONS), gctime(NREGIONS),
   xtime(NREGIONS), maxdep
   integer sstat        # accumulate statistics if nonzero
   integer ncalls       # number of calls to the allocation routine
   integer nallc        # total number of elements allocated
   integer ngcs         # number of calls to the garbage collector
   integer nxpn         # number of times reqion was expanded
   integer nrec         # total number of elements recovered
   integer gctime       # total time (in ms) spent in reclamation
   integer xtime        # total time (in ms) spent in expansion
   integer maxdep       # highest depth of heap while marking
#-h- csym.dat        1088 asc 20-oct-80 02:17:12
## csym -- symbol table structure for translator
#
common /csym/ ilast, intgtb(MAXINTGS), rlast, realtb(MAXREALS),
              slast, strgtb(MAXSTRGS), glast, gbltb(MAXGBLS),
              plast, proctb(MAXPROCS), cptop, symtb(MAXSYMTB), sylast,
              rdlast, recdtb(MAXRECDS), fdlast
   integer ilast        # last integer in intgtb
   integer intgtb       # integer table
   integer rlast        # last real in realtb
   real    realtb       # real table
   integer slast        # last string in strgtb
   integer strgtb       # string table
   integer glast        # last global in gbltb
   integer proctb       # procedure data table
   integer plast        # last entry in proctb
   integer gbltb        # global symbol table
   integer cptop        # current procedure top
   integer symtb        # table of all string and symbol characters
   integer sylast       # pointer to last character in symtb
   integer rdlast       # pointer to last record definition
   integer recdtb       # table of record definitions
   integer fdlast       # index of next field name slot
#-h- ctend.dat       1437 asc 20-oct-80 02:17:13
## ctend: tended common
#
common /ctend/ vbtab, namtab, strgtb, cstack, lasts2, lasts3,
   cntvec, ascii, lcase, ucase, ncset, bcset, subjec, cproc,
   intgtb, realtb, lpcset, rpcset, blkstr, input, output, acset,
   csetk
   define(NTENDED, 23)  # number of tended words in ctend
   pointer vbtab        # pointer to value table
   pointer namtab       # pointer to name table
   pointer strgtb       # pointer to string literal table
   pointer cstack       # pointer to the control stack
   pointer lasts2       # most recent second argument to map
   pointer lasts3       # most recent third argument to map
   pointer cntvec       # vector for token counting
   pointer ascii        # ascii string
   pointer lcase        # lower case string
   pointer ucase        # upper case string
   pointer ncset        # null character set
   pointer bcset        # character set with only BLANK in it
   pointer subjec       # pointer to &subject value
   pointer cproc        # proc being initialized
   pointer intgtb       # pointer to integer literal table
   pointer realtb       # pointer to real literal table
   pointer lpcset       # left paren character set
   pointer rpcset       # right paren character set
   pointer blkstr       # string of one blank character
   pointer input        # standard input file
   pointer output       # standard output file
   pointer acset        # cset(&ascii)
   pointer csetk        # &cset
#-h- ctio.dat         400 asc 20-oct-80 02:17:14
## ctio:  i/o common for translator
#
common /ctio/ errfd, srcfd(MAXLEVEL), lstfd, tmpfd, genfd, tokfd
   integer errfd        # default error file descriptor
   integer srcfd        # source input file stack
   integer lstfd        # list file descriptor
   integer tmpfd        # intermediate scratch file
   integer genfd        # generated fortran file
   integer tokfd        # token trace file
#-h- ctrans.dat       565 asc 20-oct-80 02:17:14
## ctrans: global variables for translator
#
 
common /ctrans/ heap(MAXHEAP), hpfree, stack(MAXSTACK), stkptr,
                trnerr, pronum, lsttn
   integer heap         # translator's node heap (for parse tree)
   integer hpfree       # indicates last used location in heap
   integer stkptr       # next available slot in stack
   integer stack        # translator's stack
   integer trnerr       # indicates if translator detected any errors
   integer pronum       # current procedure number
   integer lsttn        # largest token number found during pass 1
#-h- cutil.dat        102 asc 20-oct-80 02:17:15
## cutil:  utility common
#
common /cutil/ cbuf(MAXCHARS)
   character cbuf       # conversion buffer
#-h- cxmap.dat        111 asc 20-oct-80 02:17:16
## cxmap: character map table
#
common /cxmap/ maptab(NCHARS)
   character maptab     # table for map function
#-h- cxsort.dat       114 asc 20-oct-80 02:17:17
## cxsort:  field offset for sorting
#
common /cxsort/ off
   integer off  # offset to field in structure sorting
