#include <stdio.h>
#define ERR 10001
#define EOS 10002
#define EOF_ 10003
FILE *fdmap[1000] = {stdin, stdout, stderr};
int fdcount = 3;
open_(fname, fmode)
int *fname, *fmode;
{
	char *name, nstr[100], *md;
	int mode = *fmode;
	FILE *f;
	
	name = nstr;
	chr_to_str(fname, name);
	while (*name == ' ')
		name++;
	/*printf("name is '%s', mode is %d\n",name,mode);*/
	if (mode == 0)
		md = "r";
	else if (mode == 1)
		md = "w";
	else {
		fprintf(stderr, "Don't grok open('%s',%d)\n",name,mode);
		exit(1);
		}
	f = fopen(name, md);
	if (f == NULL) {
		fprintf(stderr, "Can't open '%s'\n", name);
		exit(1);
		}
	/*printf("fopen[%d] is %x\n",fdcount,f);*/
	fdmap[fdcount] = f;
	return fdcount++;
}
create_(fname, fmode)
{
	return open_(fname, fmode);
}
remark_(s)
char *s;
{
	while (*s != '.')
		fputc(*s++, stderr);
	fprintf(stderr,".\n");
	fflush(stderr);
}
syserr_(s)
{
	remark_(s);
}
runtim_()
{
	return 0;
}
date4_(date,year,time,secs)
int *date, *year, *time, *secs;
{
	*date = 608;
	*year = 1985;
	*time = 318;
	*secs = 14;
}

close_(fdp)
int *fdp;
{
	fclose(fdmap[*fdp]);
}
dup_(fdp)
int *fdp;
{
	int nfd;
	
	nfd = dup(fileno(fdmap[*fdp]));
	fdmap[fdcount] = fdopen(nfd,"w");
	return fdcount++;
}
exit_()
{
	exit(0);
}
terror_(s)
{
	remark_(s);
	exit(1);
}
getch_(ch, fdp)
int *ch; int *fdp;
{
	int c;
	
	c = fgetc(fdmap[*fdp]);
	if (c == EOF)
		c = EOF_;
	*ch = c;
	return c;
}
putch_(c, fdp)
int *c; int *fdp;
{
	fputc(*c,fdmap[*fdp]);
}
chr_to_str(ch,st)
int *ch; char *st;
{
	while (*ch != EOS)
		*st++ = *ch++;
	*st = NULL;
}
dmpstr_(s)
int *s;
{
	char ln[100];
	
	chr_to_str(s,ln);
	fprintf(stderr, "'%s'\n", ln);
	fflush(stderr);
}
llc_(c, a, i)
int *c, *i; char *a;
{
	
	*c = a[*i];
	return *c;
}
ldc_(c, a, i)
int *c, *i; char *a;
{
	*c = a[*i];
	return *c;
}
stc_(c, a, i)
int *c, *i; char *a;
{
	a[*i] = *c;
	return *c;
}
tstb_(a, i)
char *a; int *i;
{
	int bloc, bitno, pval;
	
	bloc = *i>>3;
	bitno = (*i&7);
	pval = a[bloc]&(1<<bitno);
	return (pval == 0 ? 0:1);
}
setb_(a, i)
char *a; int *i;
{
	int bloc, bitno, pval;
	
	bloc = *i>>3;
	bitno = (*i&7);
	pval = a[bloc]&(1<<bitno);
	a[bloc] |= (1<<bitno);
	return (pval == 0 ? 0:1);
}
